
/*import all node modules*/
var http 			    = require('http');
var express 		  =	require('express');
var app 			    = express();
var mysql			    = require('mysql');
var bodyParser 		= require('body-parser');
path 				=	require('path');
var fs            = require('fs');
var parseFormdata = require('parse-formdata');

//set the port
app.set('port', 3000);

/*parse all form data*/
app.use(bodyParser.urlencoded({ extended: true }));

/*formatting dates*/
var dateFormat = require('dateformat');
var now = new Date();

/*view engine template parsing*/

app.set('view engine','ejs');


/*import all JS and CSS files*/
app.use(express.static(path.join(__dirname, '/public')));
app.use('/js',express.static(__dirname + '/node_modules/bootstrap/dist/js'));
app.use('/js',express.static(__dirname + '/node_modules/tether/dist/js'));
app.use('/js',express.static(__dirname + '/node_modules/jquery/dist'));
app.use('/css',express.static(__dirname + '/node_modules/bootstrap/dist/css'));
app.use('/js',express.static(__dirname + '/node_modules/socket.io-client/dist'));
app.use('/css',express.static(__dirname + '/css'));
app.use('/js',express.static(__dirname + '/js'));


/*database connection */

var con = mysql.createConnection({

  host: "localhost",
  user: "root",
  password: "root",
  database : 'capsule2',
  socketPath : '/Applications/MAMP/tmp/mysql/mysql.sock'
  });

con.connect(function(err) {
  if (err) throw err;
  console.log("Connected! -------------------------------------------------------------------");
});


const siteTitle = "Capsule conversationnelle";
const baseURL = "http://localhost:3000";

var lieu = "";
var contributeur = "";
var admin_done = false;


app.get('/',function(req,res){
    /*liste audio, console.log(result);*/
    console.log(req);

    if (req.query.lieu){
	lieu = req.query.lieu;
	contributeur = req.query.contributeur;
	admin_done = true;
    }
    	    
    if(admin_done){
	res.render('pages/accueil.ejs',{
	    siteTitle : "Capsule conversationnelle",
	    pageTitle : "Accueil",
	    items : ''	
	});
    }else{
	res.render('pages/admin.ejs', {
	    siteTitle: "Capsule conversationnelle",
	    pageTitle: "Admin",
	    lieu: lieu,
	    contributeur: contributeur
	});
    }
	    
});

app.get('/admin', function(req, res){
    console.log('lieu: ', lieu);
    console.log('contributeur: ', contributeur);
    res.render('pages/admin.ejs', {
	siteTitle: "Capsule conversationnelle",
	pageTitle: "Admin",
	lieu: lieu,
	contributeur: contributeur
    });
});


// app.get('/ecoutezS',function(req,res){ 
// 	con.query("SELECT * FROM record ORDER BY RAND( )LIMIT 0,5",function(err,result){
// 	    /*liste audio, console.log(result);*/
// 	    res.render('pages/ecoutezS.ejs',{
// 			  siteTitle : "Capsule conversationnelle",
// 			  pageTitle : "ecoutezS",
// 			  items : result
// 	    });
//       console.log("Oups  ");
//     });
// });


app.get('/ecoutezS',function(req,res){
    console.log("ecoutezS");
    console.log(req.query.name_field);
    /*con.query("SELECT DISTINCT * FROM record WHERE MATCH (`dc:subject`,`title`,`description`) AGAINST ('mariée' IN NATURAL LANGUAGE MODE) GROUP BY title LIMIT 0,5",function(err,result){
      liste audio, console.log(result);*/
    // con.query("SELECT DISTINCT * FROM record WHERE MATCH (`dc:subject`,`title`,`description`) AGAINST ('mariee' IN NATURAL LANGUAGE MODE) GROUP BY title LIMIT 0,5",function(err,result){
    var mysql_query;
    if (req.query.name_field){
	mysql_query = "SELECT DISTINCT src, title FROM record WHERE MATCH (`subject`, `title`, `description`) AGAINST ('" + req.query.name_field +"*' IN BOOLEAN MODE ) LIMIT 0,5";

	console.log(mysql_query);
    }else{
	mysql_query = "SELECT * FROM record ORDER BY RAND( )LIMIT 0,5";
    }
    con.query(mysql_query,function(err,result){
	console.log('res', result);
	
	res.render('pages/ecoutezS.ejs',{
            siteTitle : "Capsule conversationnelle",
            pageTitle : "ecoutez",
            items : result
	});
	console.log("Oups  ");
    });

});


app.get('/ecoutezC',function(req,res){
	/*app.get('/event/add',function(req,res){
	liste audio, console.log(result);*/
	res.render('pages/ecoutezC.ejs',{
		siteTitle : siteTitle,
		pageTitle : '',
		items : '', 
	});
});


app.get('/enregistrezS',function(req,res){
	/*app.get('/event/add',function(req,res){
	liste audio, console.log(result);*/
	res.render('pages/enregistrezS.ejs',{
		siteTitle : siteTitle,
		pageTitle : '',
		items : ''  
	});
});


// app.post('/enregistrezS', function(req,res){
// 	var query= "INSERT INTO record (title,src) VALUES ('"+req.body.title+"', '"+req.body.src+"')"
// 	con.query(query,function (err,result){
// 		res.redirect(baseURL);
// 	});
// });


app.get('/enregistrezC',function(req,res){
/*app.get('/event/add',function(req,res){
  liste audio, console.log(result);*/
  res.render('pages/enregistrezC.ejs',{
      siteTitle : siteTitle,
      pageTitle : '',
      items : ''  
  });
});


app.post('/ajoutez', function(req, res){
  parseFormdata(req, function (err, data) {
    if (err) throw err	
    const writable = fs.createWriteStream('public/voix/' + data.fields.filename + '.mp3');
    data.parts[0].stream.pipe(writable);
    console.log(data.fields);
    var query = 'INSERT INTO record (title, src, subject, contributor, `spatial`) VALUES ("'
	+ data.fields.title + '", "'
	+ '/voix/' + data.fields.filename + '.mp3", "'
	+ data.fields["subject"] + '", "'  
	+ data.fields.contributor + '", "'
	+ lieu + '")'
    console.log("query: " + query);
    con.query(query,function (err,result){
      if(err)throw err;
	    console.log('success');
    });
    // Placer l'actualisation de la fenetre (16-11-2018)
  });
});

/*connect to server*/

// Listen for requests
var server = app.listen(app.get('port'), function () {
  console.log('The server is running on http://localhost:' + app.get('port'));
})

// Gerard 1-11-2018


// WebSocket Portion
// WebSockets work with the HTTP server
var io = require('socket.io').listen(server);

// Register a callback function to run when we have an individual connection
// This is run for each individual user that connects
io.sockets.on('connection', function (socket) { // We are given a websocket object in our function
    
    console.log("We have a new client: " + socket.id);
    
    // When this user emits, client side: socket.emit('otherevent',some data);
    socket.on('Capsule', function(data) {
	// Data comes in as whatever was sent, including objects
	// console.log("Received: 'PlayFile1' " + data.x + " " + data.y);
	console.log("Received: 'Capsule' " + data.x + " " + data.y );
	// Send it to all other clients
	socket.broadcast.emit('Capsule', data);
	// This is a way to send to everyone including sender
	// io.sockets.emit('message', "this goes to everyone");
    });
    
    socket.on('Tablette', function(data) {
	// Data comes in as whatever was sent, including objects
	// console.log("Received: 'PlayFile1' " + data.x + " " + data.y);
	console.log("Received: 'Tablette' " + data.x + " " + data.y );
	// Send it to all other clients
	socket.broadcast.emit('Tablette', data);
	// This is a way to send to everyone including sender
	// io.sockets.emit('message', "this goes to everyone");
    });
    
    socket.on('Query', function(data){
	console.log('query', data);
	socket.broadcast.emit('Query', data);
    });
    
    socket.on('disconnect', function() {
	console.log("Client has disconnected");
    });
}
);

